<?xml version="1.0"?>

<st-source>
<time-stamp>From VisualWorks®, 7.3.1 of April 20, 2005 on March 12, 2010 at 12:11:03 pm</time-stamp>
<!-- Changes from: PV-DM-Support(Green.28,spair)  to: PV-DM-Support(Green.29,carry) -->


<methods>
<class-id>PROVISO.PvThresholdDefinition class</class-id> <category>database support</category>

<body package="PV-DM-Support" selector="selectStatementWithParameters:">selectStatementWithParameters: parametersDictionary 
	"This is the most generic select statement builder in our system.  In order to consolidate the entry point, we will encode special values for building different sql statements.
		If parametersDictionary doesn't include collectorList then we are selecting for all collectors
		if parametersDictionary doesn't include startSeconds, then we are doing a before date select"
	
	| realStartSeconds namedReplacements startSeconds endSeconds collectors |
	startSeconds := 
		parametersDictionary 
			at: #startSeconds
			ifAbsent: [0].
	endSeconds := 
		parametersDictionary 
			at: #endSeconds
			ifAbsent: [self timeFacade now asSeconds].
	collectors := 
		parametersDictionary 
			at: #collectors
			ifAbsent: [nil].
	realStartSeconds := startSeconds.
	namedReplacements := Dictionary new.
	namedReplacements at: 'TABLE' put: self historyTableName asString.
	namedReplacements at: 'ELEMENTHISTORYTABLE' put: PvElement historyTableName asString.
	namedReplacements at: 'SUBELEMENTHISTORYTABLE' put: 
		PvSubelement historyTableName asString.
	namedReplacements at: 'SUBQUERYDATECONDITION' put: ' &lt;= ' , endSeconds asString.
	namedReplacements at: 'COLUMNLIST' put: 
		(self allHistoricalColumnsForSelectWithPrefix: 't1.').
	startSeconds &gt; 0 
		ifTrue: 
			[namedReplacements at: 'PRIMARYDATECONDITION' put: 
				' BETWEEN ' , realStartSeconds asString , ' AND ' , endSeconds asString , ' ']
		ifFalse: 
			[namedReplacements at: 'PRIMARYDATECONDITION' put: ' &lt;= ' , endSeconds asString , ' '].
	collectors notNil 
		ifTrue: 
			[namedReplacements 
				at: 'COLLECTORCLAUSE'
				put: 
					'e.int_collector IN ' , (self inStatementForCollectors: collectors) asString , 
						' AND ']
		ifFalse: [namedReplacements at: 'COLLECTORCLAUSE' put: ' '].
	^'SELECT /*+ ORDERED NO_MERGE(VIEW1) USE_HASH(VIEW1 t1) */ 
		%COLUMNLIST 
	FROM ( SELECT 0 as idx_ind FROM DUAL
			UNION ALL
			SELECT /*+ push_subq use_nl(e, se) ORDERED */ 
				se.idx_ind as idx_ind
			FROM
				%ELEMENTHISTORYTABLE e,
				%SUBELEMENTHISTORYTABLE se 
			WHERE %COLLECTORCLAUSE
				e.dte_date = ( SELECT MAX(e1.dte_date)
									FROM %ELEMENTHISTORYTABLE e1
									WHERE e1.idx_ind = e.idx_ind
										AND e1.dte_date %SUBQUERYDATECONDITION)
				AND e.str_action IN (''I'', ''U'')
				AND e.idx_ind &gt;= -1E10
				AND e.idx_ind = se.idx_host
				AND se.dte_date = ( SELECT MAX(se1.dte_date)
									FROM %SUBELEMENTHISTORYTABLE se1
									WHERE se1.idx_ind = se.idx_ind
										AND se1.idx_host = se.idx_host
										AND se1.dte_date %SUBQUERYDATECONDITION)
				AND se.str_action IN (''I'', ''U'')   ) VIEW1,
		%TABLE t1
	WHERE view1.idx_ind = t1.idx_resource
		AND t1.dte_hist_date = ( SELECT MAX (t2.dte_hist_date)
									FROM %TABLE t2
									WHERE t1.idx_metric = t2.idx_metric
										AND t1.idx_group = t2.idx_group
										AND t1.idx_resource = t2.idx_resource
										AND t2.dte_hist_date %PRIMARYDATECONDITION)
		AND t1.dte_hist_date %PRIMARYDATECONDITION ' namedBindWithArguments: 
			namedReplacements</body>
</methods>


<methods>
<class-id>PROVISO.PvRelation class</class-id> <category>database support</category>

<body package="PV-DM-Support" selector="selectStatementWithParameters:">selectStatementWithParameters: parametersDictionary 
	"self dbSession execute: 
		(self 
		selectStatementWithParameters: ((#startSeconds-&gt;0),(#endSeconds-&gt;PvTimestamp nowAsSeconds),(#collectors-&gt;#(1 2 3 4 5)))))"
	"This is the most generic select statement builder in our system.  In order to consolidate the entry point, we will encode special values for building different sql statements.
		If parametersDictionary doesn't include collectorList then we are selecting for all collectors
		if parametersDictionary doesn't include startSeconds, then we are doing a before date select"
	
	| realStartSeconds namedReplacements startSeconds endSeconds collectors |
	startSeconds := 
		parametersDictionary 
			at: #startSeconds
			ifAbsent: [0].
	endSeconds := 
		parametersDictionary 
			at: #endSeconds
			ifAbsent: [self timeFacade now asSeconds].
	collectors := 
		parametersDictionary 
			at: #collectors
			ifAbsent: [nil].
	realStartSeconds := startSeconds.
	namedReplacements := Dictionary new.
	namedReplacements at: 'TABLE' put: self historyTableName asString.
	namedReplacements at: 'ELEMENTHISTORYTABLE' put: PvElement historyTableName asString.
	namedReplacements at: 'SUBELEMENTHISTORYTABLE' put: 
		PvSubelement historyTableName asString.
	startSeconds &gt; 0 
		ifTrue: 
			[namedReplacements at: 'PRIMARYDATECONDITION' put: 
				' BETWEEN ' , realStartSeconds asString , ' AND ' , endSeconds asString , ' ']
		ifFalse: 
			[namedReplacements at: 'PRIMARYDATECONDITION' put: ' &lt;= ' , endSeconds asString , ' '].
	namedReplacements at: 'SUBQUERYDATECONDITION' put: ' &lt;= ' , endSeconds asString.
	self isHistorical 
		ifTrue: 
			[namedReplacements at: 'COLUMNLIST' put: 
				(self allHistoricalColumnsForSelectWithPrefix: 't1.')]
		ifFalse: 
			[namedReplacements at: 'COLUMNLIST' put: (self allColumnsForSelectWithPrefix: 't1.')].
	(self isFilteredByCollector and: [collectors notNil]) 
		ifTrue: 
			[namedReplacements at: 'COLLECTORCLAUSE' put: 
				'e.int_collector IN ' , (self inStatementForCollectors: collectors) asString, ' AND ']
		ifFalse: [namedReplacements at: 'COLLECTORCLAUSE' put: ' '].
	^'SELECT /*+ NO_MERGE(VIEW1) USE_NL(VIEW1 t1)  ORDERED */
 		%COLUMNLIST 
	FROM (SELECT /*+ push_subq use_nl(e, se)  ORDERED */   
               se.idx_ind AS idx_ind
         FROM elmt_desc_hist e, se_desc_hist se
        WHERE %COLLECTORCLAUSE
          	e.dte_date =
                       (SELECT MAX (e1.dte_date)
                          FROM elmt_desc_hist e1
                         WHERE e1.idx_ind = e.idx_ind AND e1.dte_date %SUBQUERYDATECONDITION)
          AND e.str_action IN (''I'', ''U'')
          AND e.idx_ind &gt;= -1e10
          AND e.idx_ind = se.idx_host
          AND se.dte_date =
                 (SELECT MAX (se1.dte_date)
                    FROM se_desc_hist se1
                   WHERE se1.idx_ind = se.idx_ind
                     AND se1.idx_host = se.idx_host
                     AND se1.dte_date %SUBQUERYDATECONDITION)
          AND se.str_action IN (''I'', ''U'')) view1,
      co_desc_hist t1
WHERE view1.idx_ind = t1.idx_member
  AND t1.dte_date =
         (SELECT MAX (t2.dte_date)
            FROM co_desc_hist t2
           WHERE t1.idx_relation = t2.idx_relation
             AND t1.idx_co = t2.idx_co
              AND t1.idx_member = t2.idx_member
             AND t2.dte_date %PRIMARYDATECONDITION)
  AND t1.dte_date %PRIMARYDATECONDITION  ' namedBindWithArguments: namedReplacements</body>
</methods>



</st-source>
